# BigEarthNet-MM v1.0 Tools
This repository contains tools for processing the BigEarthNet Multi-Modal (denoted as BigEarthNet-MM) v1.0 benchmark archive consisting of BigEarthNet-S1 v1.0 and BigEarthNet-S2 v1.0.
For the detailed explanation about the archive and downloading the archive, you can visit the website of BigEarthNet: [http://bigearth.net/](http://bigearth.net/).

* Tools are written in Python at the moment.
* All the codes are tested in Python 2.7 and 3.5 on Ubuntu 16.04 at the moment.
* To use the tools, you may need to first download the archive from the website. 

If you use the BigEarthNet-MM v1.0 tools, please cite the paper given below:

> G. Sumbul, A. d. Wall, T. Kreuziger, F. Marcelino, H. Costa, P. Benevides, M. Caetano, B. Demir, V. Markl, “[BigEarthNet-MM: A Large Scale Multi-Modal Multi-Label Benchmark Archive for Remote Sensing Image Classification and Retrieval](https://arxiv.org/abs/2105.07921)”,  IEEE Geoscience and Remote Sensing Magazine, vol. 9, no. 3, pp. 174-180, 2021, doi: 10.1109/MGRS.2021.3089174.

```
@article{BigEarthNet-MM,
      title={BigEarthNet-MM: A Large Scale Multi-Modal Multi-Label Benchmark Archive for Remote Sensing Image Classification and Retrieval}, 
      author={Gencer Sumbul, Arne de Wall, Tristan Kreuziger, Filipe Marcelino, Hugo Costa, Pedro Benevides, Mário Caetano, Begüm Demir and Volker Markl},
      journal={IEEE Geoscience and Remote Sensing Magazine},
      volume={9},
      number={3},
      pages={174-180},
      year={2021},
      doi={10.1109/MGRS.2021.3089174}
}
```

List of Tools and How to Use Them
-----
 
#### Python script to read Sentinel-1/Sentinel-2 image pairs from BigEarthNet-S1 v1.0/BigEarthNet-S2 v1.0 ([read_patches.py](https://git.tu-berlin.de/rsim/BigEarthNet-MM_tools/-/blob/master/scripts/read_patches.py))

This script reads GeoTIFF files for each of the spectral and radar bands of a pair of Sentinel-1 and Sentinel-2 image patches in the corresponding BigEarthNet v1.0 archives.
The script is capable of reading either all spectral radar bands of one patch pair (-p1 option for Sentinel-1 and -r2 for BigEarthNet-S2 root folder to lookup the corresponding patch from)
or all bands for all Sentinel-1 and corresponding Sentinel-2 patches (-r1 and -r2 option).
After reading the files, the values of the Sentinel-1 and Sentinel-2 image patches can be used as numpy arrays for further purposes. 

* Examples:

```
python read_patches.py -p BigEarthNet-S1-v1.0/S2A_MSIL2A_20171104T095201_5_43/ -r2 BigEarthNet-S2-v2.0/
python read_patches.py -r1 BigEarthNet-S1-v1.0/ -r2 BigEarthNet-S2-v1.0/
```

* Requirements for running:

The BigEarthNet-MM v1.0 archive should be downloaded first.
Either [GDAL](https://pypi.org/project/GDAL/) or [rasterio](https://github.com/mapbox/rasterio/) package should be installed. To use the resulting pixel values of patches, [NumPy](http://www.numpy.org/) package can also be installed. 


# Author
Arne de Wall

# Maintained by
**[RSiM Team](https://www.rsim.tu-berlin.de/menue/team)**

# License
The BigEarthNet archive is licensed under the **Community Data License Agreement – Permissive, Version 1.0** ([Text](https://cdla.io/permissive-1-0/)).

The code in this repository to facilitate the use of the archive is licensed under the **MIT License**:

```
MIT License

Copyright (c) 2020 The BigEarthNet Authors

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
```
